# Add conditional and ...
%if 0%{?suse_version} > 1310 || 0%{?fedora} >= 26 || 0%{?rhel} >= 8
# ... enable by default on newer distros.
%bcond_without  python3
%else
# ... disable by default on older distros.
%bcond_with     python3
%endif

# Fedora 30 deprecated Python 2, 31 disabled support for building these
# packages.
%if 0%{?fedora} >= 31
%bcond_with    python2
%else
%bcond_without python2
%endif

# Provide a default implementation, essentially for non-*SuSE platforms.
%if 0%{?with_python3}
%if ( ! ( 0%{?rhel} ) )
%global name_helper_python3 python3
%if 0%{?with_python2}
%global name_helper_python2 python2
%{?!python_module:%global python_module() python-%{**} python3-%{**}}
%else
%global name_helper_python2 %{nil}
%{?!python_module:%global python_module() python3-%{**}}
%endif
%else
%if 0%{?rhel} >= 7
%global name_helper_python3 python%{python3_pkgversion}
%if 0%{?with_python2}
%global name_helper_python2 python2
%{?!python_module:%global python_module() python-%{**} python%{python3_pkgversion}-%{**}}
%else
%global name_helper_python2 %{nil}
%{?!python_module:%global python_module() python%{python3_pkgversion}-%{**}}
%endif
%else
%global name_helper_python3 python34
%if 0%{?with_python2}
%global name_helper_python2 python
%{?!python_module:%global python_module() python-%{**} python34-%{**}}
%else
%global name_helper_python2 %{nil}
%{?!python_module:%global python_module() python34-%{**}}
%endif
%endif
%endif
%else
%global name_helper_python3 %{nil}
%if 0%{?with_python2}
%global name_helper_python2 python
%{?!python_module:%global python_module() python-%{**}}
%else
%global name_helper_python2 %{nil}
%{?!python_module:%global python_module()}
%endif
%endif

%if ! 0%{?with_python3}
%global         skip_python3 1
%endif

%if ! 0%{?with_python2}
%global         skip_python2 1
%endif

# Workaround for OpenSuSE Leap 42.3. This is the first version to introduce
# the macros, but in a broken state. It will generate pythonX dependencies
# if pythonX has been installed in the build environment and not honor
# skip_pythonX.
# Override to the expected behavior.
%if 0%{?sle_version} && 0%{?sle_version} == 120300 && 0%{?is_opensuse}
%if 0%{?with_python3}
%if 0%{?with_python2}
%global python_module() python-%{**} python3-%{**}
%else
%global python_module() python3-%{**}
%endif
%else
%if 0%{?with_python2}
%global python_module() python-%{**}
%else
%global python_module()
%endif
%endif
%endif

Name:           python-x2go
Version:        0.6.1.2
Release:        0.0x2go1%{?dist}
Summary:        Python module providing X2Go client API

Group:          Development/Languages
%if 0%{?suse_version}
License:        AGPL-3.0+
%else
License:        AGPLv3+
%endif
URL:            http://www.x2go.org/
Source0:        http://code.x2go.org/releases/source/%{name}/%{name}-%{version}.tar.gz

BuildArch:      noarch
# OpenSuSE Leap or SLE and either OpenSuSE Leap 42.2 or lower               or        SLE
%if 0%{?with_python2}
%if 0%{?sle_version} && ( ( 0%{?sle_version} < 120300 && 0%{?is_opensuse} ) || ( ! 0%{?is_opensuse} ) )
# On some *SuSE versions, we still need python-devel, even though we also enable Python 3
# builds there and consequently should build-depend upon python2-devel... but it doesn't
# exist there.
BuildRequires:  python-devel
%else
BuildRequires:  %{name_helper_python2}-devel
%endif
%endif
%if 0%{?with_python3}
BuildRequires:  %{name_helper_python3}-devel
%endif
%if ( 0%{?sle_version} && 0%{?sle_version} >= 120300 && 0%{?is_opensuse} ) || ( 0%{?suse_version} > 1500 )
BuildRequires:  python-rpm-macros
%endif
BuildRequires:  fdupes
BuildRequires:  %{python_module setuptools}
# For doc build
%if 0%{?suse_version}
BuildRequires:  %{python_module Sphinx}
%else
BuildRequires:  %{python_module sphinx}
%endif
BuildRequires:  %{python_module future}
BuildRequires:  %{python_module gevent}
BuildRequires:  %{python_module paramiko}
%if ( 0%{?sle_version} && 0%{?sle_version} >= 150000 && 0%{?is_opensuse} ) || ( 0%{?suse_version} > 1500 )
BuildRequires:  %{python_module python-xlib}
%else
BuildRequires:  %{python_module xlib}
%endif
BuildRequires:  %{python_module requests}
BuildRequires:  %{python_module simplejson}
%if 0%{?suse_version}
# On *SuSE, we don't have a python3 configparser module, probably because
# it's part of the standard distribution anyway.
BuildRequires:  python-configparser
%else
BuildRequires:  %{python_module configparser}
%endif

%description
X2Go is a server based computing environment with:
   - session resuming
   - low bandwidth support
   - session brokerage support
   - client side mass storage mounting support
   - audio support
   - authentication by smartcard and USB stick

This Python module allows you to integrate X2Go client support into your
Python applications by providing a Python-based X2Go client API.

%if 0%{?with_python2}
%if "%{name_helper_python2}-x2go" != "%{name}"
%package -n %{name_helper_python2}-x2go
%endif
Summary:        %{summary}
Group:          Development/Languages
Requires:       python-gevent
Requires:       python-paramiko >= 1.15.1
%if ( 0%{?sle_version} && 0%{?sle_version} >= 150000 && 0%{?is_opensuse} ) || ( 0%{?suse_version} > 1500 )
Requires:       python-python-xlib
%else
Requires:       python-xlib
%endif
Requires:       python-requests
Requires:       python-simplejson
Requires:       python-future
Requires:       python-configparser
Requires:       nxproxy
%{?python_provide:%python_provide %{name_helper_python2}-x2go}

%if "%{name_helper_python2}-x2go" != "%{name}"
%description -n %{name_helper_python2}-x2go
X2Go is a server based computing environment with:
   - session resuming
   - low bandwidth support
   - session brokerage support
   - client side mass storage mounting support
   - audio support
   - authentication by smartcard and USB stick

This Python module allows you to integrate X2Go client support into your
Python applications by providing a Python-based X2Go client API.
%endif
%endif


%if 0%{?with_python3}
%package -n %{name_helper_python3}-x2go
Summary:        %{summary}
Group:          Development/Languages
Requires:       %{name_helper_python3}-gevent
Requires:       %{name_helper_python3}-paramiko >= 1.15.1
%if ( 0%{?sle_version} && 0%{?sle_version} >= 150000 && 0%{?is_opensuse} ) || ( 0%{?suse_version} > 1500 )
Requires:       %{name_helper_python3}-python-xlib
%else
Requires:       %{name_helper_python3}-xlib
%endif
Requires:       %{name_helper_python3}-requests
Requires:       %{name_helper_python3}-simplejson
Requires:       %{name_helper_python3}-future
%if ! 0%{?suse_version}
Requires:       %{name_helper_python3}-configparser
%endif
Requires:       nxproxy
%{?python_provide:%python_provide %{name_helper_python3}-%{srcname}}

%description -n %{name_helper_python3}-x2go
X2Go is a server based computing environment with:
   - session resuming
   - low bandwidth support
   - session brokerage support
   - client side mass storage mounting support
   - audio support
   - authentication by smartcard and USB stick

This Python module allows you to integrate X2Go client support into your
Python applications by providing a Python-based X2Go client API.
%endif
# with_python3


%package        doc
Summary:        Python X2Go client API documentation
Group:          Documentation
Requires:       %{name} = %{version}-%{release}

%description    doc
This package contains the Python X2Go client API documentation.


%prep
%setup -q
# Remove shbang from library scripts
find x2go -name '*.py' | xargs sed -i '1s|^#!/usr/bin/env python||'


%build
%if 0%{?with_python2}
%if 0%{?suse_version}
%if 0%{?sle_version} && ( ( 0%{?sle_version} < 120300 && 0%{?is_opensuse} ) || ( ! 0%{?is_opensuse} ) )
python2 setup.py build
%else
%{python2_build}
%endif
%else
%{py2_build}
%endif
%endif
%if 0%{?with_python3} && ( ! ( 0%{?rhel} ) || 0%{?rhel} > 7 )
%if 0%{?suse_version}
%if 0%{?sle_version} && ( ( 0%{?sle_version} < 120300 && 0%{?is_opensuse} ) || ( ! 0%{?is_opensuse} ) )
python3 setup.py build
%else
%{python3_build}
%endif
%else
%{py3_build}
%endif
%endif
# with_python3

# Build the docs
make -f Makefile.docupload docbuild


%install
%if 0%{?with_python2}
%if 0%{?suse_version}
%if 0%{?sle_version} && ( ( 0%{?sle_version} < 120300 && 0%{?is_opensuse} ) || ( ! 0%{?is_opensuse} ) )
python2 setup.py install --skip-build --root %{buildroot}
%else
%{python2_install} --skip-build
%endif
%else
%{py2_install}
%endif
%endif
%if 0%{?with_python3} && ( ! ( 0%{?rhel} ) || 0%{?rhel} > 7 )
%if 0%{?suse_version}
%if 0%{?sle_version} && ( ( 0%{?sle_version} < 120300 && 0%{?is_opensuse} ) || ( ! 0%{?is_opensuse} ) )
python3 setup.py install --skip-build --root %{buildroot}
%else
%{python3_install} --skip-build
%endif
%else
%{py3_install}
%endif
%endif
# with_python3
%if 0%{?fdupes:1}
%fdupes %{buildroot}/%{_prefix}
%endif


%files doc
%defattr(-,root,root)
%doc docs/build/html

%if 0%{?with_python2}
%if "%{name_helper_python2}-x2go" == "%{name}"
%files
%else
%files -n %{name_helper_python2}-x2go
%endif
%defattr(-,root,root)
%license COPYING
%doc README* TODO
%if 0%{?suse_version}
%if ( 0%{?sle_version} && 0%{?sle_version} >= 120300 && 0%{?is_opensuse} ) || ( 0%{?suse_version} > 1500 )
%{python2_sitelib}/x2go/
%{python2_sitelib}/x2go-*
%pycache_only %{python2_sitelib}/__pycache__
%else
%{python_sitelib}/x2go/
%{python_sitelib}/x2go-*/
%endif
%else
%{python2_sitelib}/x2go/
%{python2_sitelib}/x2go-*/
%endif
%endif


%if 0%{?with_python3}
%files -n %{name_helper_python3}-x2go
%defattr(-,root,root)
%license COPYING
%doc README* TODO
%{python3_sitelib}/*
%if 0%{?suse_version}
%if ( 0%{?sle_version} && 0%{?sle_version} >= 120300 && 0%{?is_opensuse} ) || ( 0%{?suse_version} > 1500 )
%pycache_only %{python3_sitelib}/__pycache__
%endif
%endif
%endif


%changelog
